-- by modelleicher
-- original function by Giants, just changed the default setting to disable the FL Joint Lock
-- You can find me at www.schwabenmodding.de or https://ls-modcompany.com/
-- Date: 09.11.2017

frontloaderFixedAxleRemover = {};

function frontloaderFixedAxleRemover:newLoad(savegame)
	if self.configurations["frontloader"] ~= nil then
		self.frontloaderAttacher = {};
		self.frontloaderAttacher.attacherJoint = {};
		local key = string.format("vehicle.frontloaderConfigurations.frontloaderConfiguration(%d)", self.configurations["frontloader"]-1);
		if self:loadAttacherJointFromXML(self.frontloaderAttacher.attacherJoint, self.xmlFile, key..".attacherJoint") then
			table.insert(self.attacherJoints, self.frontloaderAttacher.attacherJoint);

			-- change default setting to false, front axles aren't locked by default when attaching a frontloader anymore
			local frontAxisLimitJoint = Utils.getNoNil(getXMLBool(self.xmlFile, key..".attacherJoint#frontAxisLimitJoint"), false)
			if frontAxisLimitJoint then
				local frontAxisJoint = Utils.getNoNil(getXMLInt(self.xmlFile, key..".attacherJoint#frontAxisJoint"), 0)
				if self.componentJoints[frontAxisJoint+1] ~= nil then
					self.frontloaderAttacher.frontAxisJoint = frontAxisJoint+1
				else
					print("Warning: Invalid front-axis joint '"..tostring(frontAxisJoint).."' in '"..self.configFileName.."'")
				end
			end

			ObjectChangeUtil.updateObjectChanges(self.xmlFile, "vehicle.frontloaderConfigurations.frontloaderConfiguration", self.configurations["frontloader"], self.components, self);
		else
			-- first config is "no-frontloader"-option
			ObjectChangeUtil.updateObjectChanges(self.xmlFile, "vehicle.frontloaderConfigurations.frontloaderConfiguration", 1, self.components, self);
			self.frontloaderAttacher = nil;
		end
	end
end

FrontloaderAttacher.load = frontloaderFixedAxleRemover.newLoad;
